//
// Created by philipp on 22.03.18.
//

#include <iostream>
#include "../include/Logging.h"

namespace pc
{

void Logging::start()
{
    using boost::asio::ip::tcp;

    if (running)
        return;

    running = true;
    tcp::endpoint endpoint{tcp::v4(), port};
    tcp::acceptor acceptor{ioService, endpoint};

    while (running)
    {
        try
        {
            tcp::iostream stream;
            boost::system::error_code ec;
            acceptor.accept(*stream.rdbuf(), ec);
            if (ec)
                continue;

            while (running)
            {
                std::string msg;
                stream >> msg;
                std::cout << msg;
                if (stream.error())
                {
                    if (stream.error() != boost::asio::error::eof)
                        std::cerr << "LOGGING ERROR: " << stream.error().message() << "\n";

                    std::cout << std::endl;
                    break;
                }
                std::cout << " ";
            }
        }
        catch (const std::exception & e)
        {
            std::cerr << "LOGGING ERROR: " << e.what() << "\n";
        }
    }
}

void Logging::stop()
{
    running = false;
}

}